diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index f043b4d7fed..75d677c58a6 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -419,6 +419,7 @@ static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINS
 static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
                             JoystickImpl **pdev, unsigned short index)
 {
+    struct JoyDev *joydev = &joystick_devices[index];
     DIDEVICEINSTANCEW didi = {sizeof(didi)};
     DWORD i;
     JoystickImpl* newDevice;
@@ -431,11 +432,12 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
     fill_joystick_dideviceinstanceW(&didi, dinput->dwVersion, index);
 
     *pdev = NULL;
-    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, &didi, dinput, (void **)&newDevice)))
+    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, joydev->vendor_id,
+                       joydev->product_id, index, &didi, dinput, (void **)&newDevice)))
         return hr;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
 
-    newDevice->joydev = &joystick_devices[index];
+    newDevice->joydev = joydev;
     newDevice->joyfd = -1;
     newDevice->generic.joy_polldev = joy_polldev;
     newDevice->generic.name        = newDevice->joydev->name;
@@ -625,10 +627,8 @@ static HRESULT WINAPI JoystickLinuxWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface
         case (DWORD_PTR) DIPROP_VIDPID:
         {
             LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
-
-            if (!This->joydev->product_id || !This->joydev->vendor_id)
-                return DIERR_UNSUPPORTED;
-            pd->dwData = MAKELONG(This->joydev->vendor_id, This->joydev->product_id);
+            if (!This->generic.base.vendor_id || !This->generic.base.product_id) return DIERR_UNSUPPORTED;
+            pd->dwData = MAKELONG(This->generic.base.vendor_id, This->generic.base.product_id);
             TRACE("DIPROP_VIDPID(%08x)\n", pd->dwData);
             break;
         }
@@ -636,7 +636,7 @@ static HRESULT WINAPI JoystickLinuxWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface
         {
             LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
 
-            pd->dwData = get_joystick_index(&This->generic.base.guid);
+            pd->dwData = This->generic.base.instance_id;
             TRACE("DIPROP_JOYSTICKID(%d)\n", pd->dwData);
             break;
         }
@@ -650,15 +650,11 @@ static HRESULT WINAPI JoystickLinuxWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface
 
             BOOL is_gamepad;
             LPDIPROPGUIDANDPATH pd = (LPDIPROPGUIDANDPATH)pdiph;
-            WORD vid = This->joydev->vendor_id;
-            WORD pid = This->joydev->product_id;
-
-            if (!pid || !vid)
-                return DIERR_UNSUPPORTED;
-
-            is_gamepad = is_xinput_device(&This->generic.devcaps, vid, pid);
+            if (!This->generic.base.vendor_id || !This->generic.base.product_id) return DIERR_UNSUPPORTED;
+            is_gamepad = is_xinput_device(&This->generic.devcaps, This->generic.base.vendor_id, This->generic.base.product_id);
             pd->guidClass = GUID_DEVCLASS_HIDCLASS;
-            sprintfW(pd->wszPath, formatW, vid, pid, is_gamepad ? igW : miW, get_joystick_index(&This->generic.base.guid));
+            sprintfW(pd->wszPath, formatW, This->generic.base.vendor_id, This->generic.base.product_id,
+                    is_gamepad ? igW : miW, This->generic.base.instance_id);
 
             TRACE("DIPROP_GUIDANDPATH(%s, %s): returning fake path\n", debugstr_guid(&pd->guidClass), debugstr_w(pd->wszPath));
             break;
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 4730ea9bc3f..025943acff1 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -413,6 +413,7 @@ static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINS
 
 static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsigned short index)
 {
+    struct JoyDev *joydev = &joydevs[index];
     DIDEVICEINSTANCEW didi = {sizeof(didi)};
     JoystickImpl* newDevice;
     LPDIDATAFORMAT df = NULL;
@@ -421,13 +422,14 @@ static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsig
 
     fill_joystick_dideviceinstanceW(&didi, dinput->dwVersion, index);
 
-    if (FAILED(direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, &didi, dinput, (void **)&newDevice)))
+    if (FAILED(direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, joydev->vendor_id,
+                joydev->product_id, index, &didi, dinput, (void **)&newDevice)))
         return NULL;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->base.crit");
 
     newDevice->generic.joy_polldev = joy_polldev;
     newDevice->joyfd       = -1;
-    newDevice->joydev      = &joydevs[index];
+    newDevice->joydev = joydev;
     newDevice->generic.name        = newDevice->joydev->name;
     list_init(&newDevice->ff_effects);
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
@@ -900,10 +902,8 @@ static HRESULT WINAPI JoystickWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
     case (DWORD_PTR) DIPROP_VIDPID:
     {
         LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
-
-        if (!This->joydev->product_id || !This->joydev->vendor_id)
-            return DIERR_UNSUPPORTED;
-        pd->dwData = MAKELONG(This->joydev->vendor_id, This->joydev->product_id);
+        if (!This->generic.base.vendor_id || !This->generic.base.product_id) return DIERR_UNSUPPORTED;
+        pd->dwData = MAKELONG(This->generic.base.vendor_id, This->generic.base.product_id);
         TRACE("DIPROP_VIDPID(%08x)\n", pd->dwData);
         break;
     }
@@ -912,7 +912,7 @@ static HRESULT WINAPI JoystickWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
     {
         LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
 
-        pd->dwData = get_joystick_index(&This->generic.base.guid);
+        pd->dwData = This->generic.base.instance_id;
         TRACE("DIPROP_JOYSTICKID(%d)\n", pd->dwData);
         break;
     }
@@ -926,15 +926,12 @@ static HRESULT WINAPI JoystickWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
 
         BOOL is_gamepad;
         LPDIPROPGUIDANDPATH pd = (LPDIPROPGUIDANDPATH)pdiph;
-        WORD vid = This->joydev->vendor_id;
-        WORD pid = This->joydev->product_id;
-
-        if (!pid || !vid)
-            return DIERR_UNSUPPORTED;
+        if (!This->generic.base.vendor_id || !This->generic.base.product_id) return DIERR_UNSUPPORTED;
 
-        is_gamepad = is_xinput_device(&This->generic.devcaps, vid, pid);
+        is_gamepad = is_xinput_device(&This->generic.devcaps, This->generic.base.vendor_id, This->generic.base.product_id);
         pd->guidClass = GUID_DEVCLASS_HIDCLASS;
-        sprintfW(pd->wszPath, formatW, vid, pid, is_gamepad ? igW : miW, get_joystick_index(&This->generic.base.guid));
+        sprintfW(pd->wszPath, formatW, This->generic.base.vendor_id, This->generic.base.product_id,
+                is_gamepad ? igW : miW, This->generic.base.instance_id);
 
         TRACE("DIPROP_GUIDANDPATH(%s, %s): returning fake path\n", debugstr_guid(&pd->guidClass), debugstr_w(pd->wszPath));
         break;
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index d13346f50e2..fb20a8f7c6e 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -1053,14 +1053,18 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
     int axis_map[8]; /* max axes */
     int slider_count = 0;
     FFCAPABILITIES ffcaps;
+    WORD vendor_id, product_id;
 
     TRACE("%s %p %p %hu\n", debugstr_guid(rguid), dinput, pdev, index);
 
     device = get_device_ref(index);
+    vendor_id = get_device_property_long(device, CFSTR(kIOHIDVendorIDKey));
+    product_id = get_device_property_long(device, CFSTR(kIOHIDProductIDKey));
 
     fill_joystick_dideviceinstanceW(&didi, device, dinput->dwVersion, index, name);
 
-    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, &didi, dinput, (void **)&newDevice)))
+    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, vendor_id, product_id, index,
+                       &didi, dinput, (void **)&newDevice)))
         return hr;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
 
@@ -1284,17 +1288,13 @@ static HRESULT WINAPI JoystickWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
         static const WCHAR igW[] = {'i','g',0};
 
         BOOL is_gamepad;
-        IOHIDDeviceRef device = get_device_ref(This->id);
         LPDIPROPGUIDANDPATH pd = (LPDIPROPGUIDANDPATH)pdiph;
-        WORD vid = get_device_property_long(device, CFSTR(kIOHIDVendorIDKey));
-        WORD pid = get_device_property_long(device, CFSTR(kIOHIDProductIDKey));
+        if (!This->generic.base.vendor_id || !This->generic.base.product_id) return DIERR_UNSUPPORTED;
 
-        if (!pid || !vid)
-            return DIERR_UNSUPPORTED;
-
-        is_gamepad = is_xinput_device(&This->generic.devcaps, vid, pid);
+        is_gamepad = is_xinput_device(&This->generic.devcaps, This->generic.base.vendor_id, This->generic.base.product_id);
         pd->guidClass = GUID_DEVCLASS_HIDCLASS;
-        sprintfW(pd->wszPath, formatW, vid, pid, is_gamepad ? igW : miW, This->id);
+        sprintfW(pd->wszPath, formatW, This->generic.base.vendor_id, This->generic.base.product_id,
+                is_gamepad ? igW : miW, This->generic.base.instance_id);
 
         TRACE("DIPROP_GUIDANDPATH(%s, %s): returning fake path\n", debugstr_guid(&pd->guidClass), debugstr_w(pd->wszPath));
         break;
diff --git a/dlls/dinput/keyboard.c b/dlls/dinput/keyboard.c
index 11d41a2ce4c..79c57c50d28 100644
--- a/dlls/dinput/keyboard.c
+++ b/dlls/dinput/keyboard.c
@@ -203,7 +203,7 @@ static SysKeyboardImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput)
 
     fill_keyboard_dideviceinstanceW(&didi, dinput->dwVersion, get_keyboard_subtype());
 
-    if (FAILED(direct_input_device_alloc(sizeof(SysKeyboardImpl), &SysKeyboardWvt, rguid, &didi, dinput, (void **)&newDevice)))
+    if (FAILED(direct_input_device_alloc(sizeof(SysKeyboardImpl), &SysKeyboardWvt, rguid, 0, 0, 0, &didi, dinput, (void **)&newDevice)))
         return NULL;
     newDevice->base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": SysKeyboardImpl*->base.crit");
 
diff --git a/dlls/dinput/mouse.c b/dlls/dinput/mouse.c
index 0e3a8976033..f81fe92cf22 100644
--- a/dlls/dinput/mouse.c
+++ b/dlls/dinput/mouse.c
@@ -149,7 +149,7 @@ static SysMouseImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput)
 
     fill_mouse_dideviceinstanceW(&didi, dinput->dwVersion);
 
-    if (FAILED(direct_input_device_alloc(sizeof(SysMouseImpl), &SysMouseWvt, rguid, &didi, dinput, (void **)&newDevice)))
+    if (FAILED(direct_input_device_alloc(sizeof(SysMouseImpl), &SysMouseWvt, rguid, 0, 0, 0, &didi, dinput, (void **)&newDevice)))
         return NULL;
     newDevice->base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": SysMouseImpl*->base.crit");
 
-- 
2.28.0

>From c1c1363698ada02d8d3471e3197a65b0f956bb41 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 13/39] dinput: Factor VIDPID/JOYSTICKID/GUIDANDPATH
 properties.

---
 dlls/dinput/joystick.c            | 36 ++++++++++++++++++-
 dlls/dinput/joystick_linux.c      | 59 +------------------------------
 dlls/dinput/joystick_linuxinput.c | 39 --------------------
 dlls/dinput/joystick_osx.c        | 39 +-------------------
 dlls/dinput/joystick_private.h    |  1 -
 5 files changed, 37 insertions(+), 137 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 72e3e8d4fd6..7acaf6b7f06 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -31,6 +31,7 @@
 #include "joystick_private.h"
 #include "wine/debug.h"
 #include "winreg.h"
+#include "devguid.h"
 
 WINE_DEFAULT_DEBUG_CHANNEL(dinput);
 
@@ -321,7 +322,7 @@ BOOL device_disabled_registry(const WCHAR* name)
     return do_disable;
 }
 
-BOOL is_xinput_device(const DIDEVCAPS *devcaps, WORD vid, WORD pid)
+static BOOL is_xinput_device(const DIDEVCAPS *devcaps, WORD vid, WORD pid)
 {
     int i;
 
@@ -637,6 +638,39 @@ HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
 
             return DI_OK;
         }
+        case (DWORD_PTR) DIPROP_VIDPID:
+        {
+            LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
+            if (!This->base.vendor_id || !This->base.product_id) return DIERR_UNSUPPORTED;
+            pd->dwData = MAKELONG(This->base.vendor_id, This->base.product_id);
+            TRACE("vidpid(%08x)\n", pd->dwData);
+            return DI_OK;
+        }
+        case (DWORD_PTR) DIPROP_JOYSTICKID:
+        {
+            LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
+            pd->dwData = This->base.instance_id;
+            TRACE("joystickid(%d)\n", pd->dwData);
+            return DI_OK;
+        }
+        case (DWORD_PTR) DIPROP_GUIDANDPATH:
+        {
+            static const WCHAR formatW[] = {'\\', '\\', '?', '\\', 'h', 'i', 'd', '#', 'v', 'i', 'd', '_', '%', '0',
+                    '4', 'x', '&', 'p', 'i', 'd', '_', '%', '0', '4', 'x', '&', '%', 's', '_', '%', 'h', 'u', 0};
+            static const WCHAR miW[] = {'m', 'i', 0};
+            static const WCHAR igW[] = {'i', 'g', 0};
+
+            BOOL is_gamepad;
+            LPDIPROPGUIDANDPATH pd = (LPDIPROPGUIDANDPATH)pdiph;
+            if (!This->base.vendor_id || !This->base.product_id) return DIERR_UNSUPPORTED;
+            is_gamepad = is_xinput_device(&This->devcaps, This->base.vendor_id, This->base.product_id);
+            pd->guidClass = GUID_DEVCLASS_HIDCLASS;
+            sprintfW(pd->wszPath, formatW, This->base.vendor_id, This->base.product_id, is_gamepad ? igW : miW,
+                    This->base.instance_id);
+
+            TRACE("guidandpath(%s, %s): returning fake path\n", debugstr_guid(&pd->guidClass), debugstr_w(pd->wszPath));
+            return DI_OK;
+        }
         default:
             return IDirectInputDevice2WImpl_GetProperty(iface, rguid, pdiph);
         }
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 75d677c58a6..4edcfd75a90 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -610,63 +610,6 @@ static HRESULT WINAPI JoystickLinuxWImpl_Acquire(LPDIRECTINPUTDEVICE8W iface)
     return DI_OK;
 }
 
-/******************************************************************************
-  *     GetProperty : get input device properties
-  */
-static HRESULT WINAPI JoystickLinuxWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPDIPROPHEADER pdiph)
-{
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
-
-    TRACE("(%p)->(%s,%p)\n", This, debugstr_guid(rguid), pdiph);
-    _dump_DIPROPHEADER(pdiph);
-
-    if (!IS_DIPROP(rguid)) return DI_OK;
-
-    switch (LOWORD(rguid)) {
-
-        case (DWORD_PTR) DIPROP_VIDPID:
-        {
-            LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
-            if (!This->generic.base.vendor_id || !This->generic.base.product_id) return DIERR_UNSUPPORTED;
-            pd->dwData = MAKELONG(This->generic.base.vendor_id, This->generic.base.product_id);
-            TRACE("DIPROP_VIDPID(%08x)\n", pd->dwData);
-            break;
-        }
-        case (DWORD_PTR) DIPROP_JOYSTICKID:
-        {
-            LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
-
-            pd->dwData = This->generic.base.instance_id;
-            TRACE("DIPROP_JOYSTICKID(%d)\n", pd->dwData);
-            break;
-        }
-
-        case (DWORD_PTR) DIPROP_GUIDANDPATH:
-        {
-            static const WCHAR formatW[] = {'\\','\\','?','\\','h','i','d','#','v','i','d','_','%','0','4','x','&',
-                                            'p','i','d','_','%','0','4','x','&','%','s','_','%','h','u',0};
-            static const WCHAR miW[] = {'m','i',0};
-            static const WCHAR igW[] = {'i','g',0};
-
-            BOOL is_gamepad;
-            LPDIPROPGUIDANDPATH pd = (LPDIPROPGUIDANDPATH)pdiph;
-            if (!This->generic.base.vendor_id || !This->generic.base.product_id) return DIERR_UNSUPPORTED;
-            is_gamepad = is_xinput_device(&This->generic.devcaps, This->generic.base.vendor_id, This->generic.base.product_id);
-            pd->guidClass = GUID_DEVCLASS_HIDCLASS;
-            sprintfW(pd->wszPath, formatW, This->generic.base.vendor_id, This->generic.base.product_id,
-                    is_gamepad ? igW : miW, This->generic.base.instance_id);
-
-            TRACE("DIPROP_GUIDANDPATH(%s, %s): returning fake path\n", debugstr_guid(&pd->guidClass), debugstr_w(pd->wszPath));
-            break;
-        }
-
-    default:
-        return JoystickWGenericImpl_GetProperty(iface, rguid, pdiph);
-    }
-
-    return DI_OK;
-}
-
 /******************************************************************************
   *     Unacquire : frees the joystick
   */
@@ -774,7 +717,7 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_Release,
     JoystickWGenericImpl_GetCapabilities,
     IDirectInputDevice2WImpl_EnumObjects,
-    JoystickLinuxWImpl_GetProperty,
+    JoystickWGenericImpl_GetProperty,
     JoystickWGenericImpl_SetProperty,
     JoystickLinuxWImpl_Acquire,
     JoystickLinuxWImpl_Unacquire,
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 025943acff1..365d0d9572c 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -898,45 +898,6 @@ static HRESULT WINAPI JoystickWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
         TRACE("DIPROP_FFGAIN(%d)\n", pd->dwData);
         break;
     }
-
-    case (DWORD_PTR) DIPROP_VIDPID:
-    {
-        LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
-        if (!This->generic.base.vendor_id || !This->generic.base.product_id) return DIERR_UNSUPPORTED;
-        pd->dwData = MAKELONG(This->generic.base.vendor_id, This->generic.base.product_id);
-        TRACE("DIPROP_VIDPID(%08x)\n", pd->dwData);
-        break;
-    }
-
-    case (DWORD_PTR) DIPROP_JOYSTICKID:
-    {
-        LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
-
-        pd->dwData = This->generic.base.instance_id;
-        TRACE("DIPROP_JOYSTICKID(%d)\n", pd->dwData);
-        break;
-    }
-
-    case (DWORD_PTR) DIPROP_GUIDANDPATH:
-    {
-        static const WCHAR formatW[] = {'\\','\\','?','\\','h','i','d','#','v','i','d','_','%','0','4','x','&',
-                                        'p','i','d','_','%','0','4','x','&','%','s','_','%','h','u',0};
-        static const WCHAR miW[] = {'m','i',0};
-        static const WCHAR igW[] = {'i','g',0};
-
-        BOOL is_gamepad;
-        LPDIPROPGUIDANDPATH pd = (LPDIPROPGUIDANDPATH)pdiph;
-        if (!This->generic.base.vendor_id || !This->generic.base.product_id) return DIERR_UNSUPPORTED;
-
-        is_gamepad = is_xinput_device(&This->generic.devcaps, This->generic.base.vendor_id, This->generic.base.product_id);
-        pd->guidClass = GUID_DEVCLASS_HIDCLASS;
-        sprintfW(pd->wszPath, formatW, This->generic.base.vendor_id, This->generic.base.product_id,
-                is_gamepad ? igW : miW, This->generic.base.instance_id);
-
-        TRACE("DIPROP_GUIDANDPATH(%s, %s): returning fake path\n", debugstr_guid(&pd->guidClass), debugstr_w(pd->wszPath));
-        break;
-    }
-
     default:
         return JoystickWGenericImpl_GetProperty(iface, rguid, pdiph);
     }
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index fb20a8f7c6e..0e9278d83b7 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -1270,43 +1270,6 @@ static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDir
     return DIERR_DEVICENOTREG;
 }
 
-static HRESULT WINAPI JoystickWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPDIPROPHEADER pdiph)
-{
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
-
-    TRACE("(%p)->(%s,%p)\n", This, debugstr_guid(rguid), pdiph);
-    _dump_DIPROPHEADER(pdiph);
-
-    if (!IS_DIPROP(rguid)) return DI_OK;
-
-    switch (LOWORD(rguid)) {
-    case (DWORD_PTR) DIPROP_GUIDANDPATH:
-    {
-        static const WCHAR formatW[] = {'\\','\\','?','\\','h','i','d','#','v','i','d','_','%','0','4','x','&',
-                                        'p','i','d','_','%','0','4','x','&','%','s','_','%','i',0};
-        static const WCHAR miW[] = {'m','i',0};
-        static const WCHAR igW[] = {'i','g',0};
-
-        BOOL is_gamepad;
-        LPDIPROPGUIDANDPATH pd = (LPDIPROPGUIDANDPATH)pdiph;
-        if (!This->generic.base.vendor_id || !This->generic.base.product_id) return DIERR_UNSUPPORTED;
-
-        is_gamepad = is_xinput_device(&This->generic.devcaps, This->generic.base.vendor_id, This->generic.base.product_id);
-        pd->guidClass = GUID_DEVCLASS_HIDCLASS;
-        sprintfW(pd->wszPath, formatW, This->generic.base.vendor_id, This->generic.base.product_id,
-                is_gamepad ? igW : miW, This->generic.base.instance_id);
-
-        TRACE("DIPROP_GUIDANDPATH(%s, %s): returning fake path\n", debugstr_guid(&pd->guidClass), debugstr_w(pd->wszPath));
-        break;
-    }
-
-    default:
-        return JoystickWGenericImpl_GetProperty(iface, rguid, pdiph);
-    }
-
-    return DI_OK;
-}
-
 static HRESULT osx_set_autocenter(JoystickImpl *This,
         const DIPROPDWORD *header)
 {
@@ -1449,7 +1412,7 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_Release,
     JoystickWGenericImpl_GetCapabilities,
     IDirectInputDevice2WImpl_EnumObjects,
-    JoystickWImpl_GetProperty,
+    JoystickWGenericImpl_GetProperty,
     JoystickWImpl_SetProperty,
     IDirectInputDevice2WImpl_Acquire,
     IDirectInputDevice2WImpl_Unacquire,
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index b82632c39d2..ca32d1b08fb 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -78,6 +78,5 @@ HRESULT WINAPI JoystickWGenericImpl_SetActionMap(LPDIRECTINPUTDEVICE8W iface, LP
 
 DWORD typeFromGUID(REFGUID guid) DECLSPEC_HIDDEN;
 void dump_DIEFFECT(LPCDIEFFECT eff, REFGUID guid, DWORD dwFlags) DECLSPEC_HIDDEN;
-BOOL is_xinput_device(const DIDEVCAPS *devcaps, WORD vid, WORD pid) DECLSPEC_HIDDEN;
 
 #endif /* __WINE_DLLS_DINPUT_JOYSTICK_PRIVATE_H */
-- 
2.28.0

>From f725ca3fed4537d765729e73ae55b7649275f3e3 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 14/39] dinput: Introduce unix vtable for joystick devices.

And use it for Poll.
---
 dlls/dinput/joystick.c            |  4 ++--
 dlls/dinput/joystick_linux.c      | 29 +++++++++++++++++++++++++----
 dlls/dinput/joystick_linuxinput.c | 29 +++++++++++++++++++++++++----
 dlls/dinput/joystick_osx.c        | 28 ++++++++++++++++++++++++----
 dlls/dinput/joystick_private.h    | 11 ++++++++---
 5 files changed, 84 insertions(+), 17 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 7acaf6b7f06..1bb7ed95180 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -690,7 +690,7 @@ HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface)
         return DIERR_NOTACQUIRED;
     }
 
-    This->joy_polldev(iface);
+    This->unix_funcs->poll(This->unix_ptr);
     return DI_OK;
 }
 
@@ -710,7 +710,7 @@ HRESULT WINAPI JoystickWGenericImpl_GetDeviceState(LPDIRECTINPUTDEVICE8W iface,
     }
 
     /* update joystick state */
-    This->joy_polldev(iface);
+    This->unix_funcs->poll(This->unix_ptr);
 
     /* convert and copy data to user supplied buffer */
     fill_DataFormat(ptr, len, &This->js, &This->base.data_format);
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 4edcfd75a90..8d0500ba035 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -107,6 +107,20 @@ static inline JoystickImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W
     return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface),
            JoystickGenericImpl, base), JoystickImpl, generic);
 }
+static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(JoystickImpl *This)
+{
+    return &This->generic.base.IDirectInputDevice8W_iface;
+}
+
+static inline struct unix_joystick *unix_joystick_from_impl(JoystickImpl *This)
+{
+    return (struct unix_joystick *)This;
+}
+
+static inline JoystickImpl *impl_from_unix_joystick(struct unix_joystick *ptr)
+{
+    return (JoystickImpl *)ptr;
+}
 
 static const GUID DInput_Wine_Joystick_GUID = { /* 9e573ed9-7734-11d2-8d4a-23903fb6bdf7 */
   0x9e573ed9,
@@ -119,7 +133,12 @@ static const GUID DInput_Wine_Joystick_GUID = { /* 9e573ed9-7734-11d2-8d4a-23903
 static INT joystick_devices_count = -1;
 static struct JoyDev *joystick_devices;
 
-static void joy_polldev(IDirectInputDevice8W *iface);
+static void CDECL unix_joystick_poll(struct unix_joystick *ptr);
+
+static const struct unix_joystick_vtbl unix_joystick_vtbl =
+{
+    unix_joystick_poll,
+};
 
 #define SYS_PATH_FORMAT "/sys/class/input/js%d/device/id/%s"
 static BOOL read_sys_id_variable(int index, const char *property, WORD *value)
@@ -436,10 +455,11 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
                        joydev->product_id, index, &didi, dinput, (void **)&newDevice)))
         return hr;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
+    newDevice->generic.unix_funcs = &unix_joystick_vtbl;
+    newDevice->generic.unix_ptr = unix_joystick_from_impl(newDevice);
 
     newDevice->joydev = joydev;
     newDevice->joyfd = -1;
-    newDevice->generic.joy_polldev = joy_polldev;
     newDevice->generic.name        = newDevice->joydev->name;
     newDevice->generic.device_axis_count = newDevice->joydev->axis_count;
     newDevice->generic.devcaps.dwButtons = newDevice->joydev->button_count;
@@ -635,11 +655,12 @@ static HRESULT WINAPI JoystickLinuxWImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface)
     return DI_NOEFFECT;
 }
 
-static void joy_polldev(IDirectInputDevice8W *iface)
+static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 {
     struct pollfd plfd;
     struct js_event jse;
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    IDirectInputDevice8W *iface = IDirectInputDevice8W_from_impl(This);
 
     TRACE("(%p)\n", This);
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 365d0d9572c..c72b5919f87 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -141,10 +141,29 @@ static inline JoystickImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W
     return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface),
            JoystickGenericImpl, base), JoystickImpl, generic);
 }
+static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(JoystickImpl *This)
+{
+    return &This->generic.base.IDirectInputDevice8W_iface;
+}
+
+static inline struct unix_joystick *unix_joystick_from_impl(JoystickImpl *This)
+{
+    return (struct unix_joystick *)This;
+}
+
+static inline JoystickImpl *impl_from_unix_joystick(struct unix_joystick *ptr)
+{
+    return (JoystickImpl *)ptr;
+}
 
 static void fake_current_js_state(JoystickImpl *ji);
 static void find_joydevs(void);
-static void joy_polldev(IDirectInputDevice8W *iface);
+static void CDECL unix_joystick_poll(struct unix_joystick *ptr);
+
+static const struct unix_joystick_vtbl unix_joystick_vtbl =
+{
+    unix_joystick_poll,
+};
 
 /* This GUID is slightly different from the linux joystick one. Take note. */
 static const GUID DInput_Wine_Joystick_Base_GUID = { /* 9e573eda-7734-11d2-8d4a-23903fb6bdf7 */
@@ -426,8 +445,9 @@ static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsig
                 joydev->product_id, index, &didi, dinput, (void **)&newDevice)))
         return NULL;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->base.crit");
+    newDevice->generic.unix_funcs = &unix_joystick_vtbl;
+    newDevice->generic.unix_ptr = unix_joystick_from_impl(newDevice);
 
-    newDevice->generic.joy_polldev = joy_polldev;
     newDevice->joyfd       = -1;
     newDevice->joydev = joydev;
     newDevice->generic.name        = newDevice->joydev->name;
@@ -716,11 +736,12 @@ static void fake_current_js_state(JoystickImpl *ji)
 #undef CENTER_AXIS
 
 /* convert wine format offset to user format object index */
-static void joy_polldev(IDirectInputDevice8W *iface)
+static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 {
     struct pollfd plfd;
     struct input_event ie;
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    IDirectInputDevice8W *iface = IDirectInputDevice8W_from_impl(This);
 
     if (This->joyfd==-1)
 	return;
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 0e9278d83b7..c0ce7547aa9 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -118,6 +118,20 @@ static inline JoystickImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W
     return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface),
            JoystickGenericImpl, base), JoystickImpl, generic);
 }
+static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(JoystickImpl *This)
+{
+    return &This->generic.base.IDirectInputDevice8W_iface;
+}
+
+static inline struct unix_joystick *unix_joystick_from_impl(JoystickImpl *This)
+{
+    return (struct unix_joystick *)This;
+}
+
+static inline JoystickImpl *impl_from_unix_joystick(struct unix_joystick *ptr)
+{
+    return (JoystickImpl *)ptr;
+}
 
 typedef struct _EffectImpl {
     IDirectInputEffect IDirectInputEffect_iface;
@@ -756,9 +770,10 @@ static void get_osx_device_elements_props(JoystickImpl *device)
     }
 }
 
-static void poll_osx_device_state(IDirectInputDevice8W *iface)
+static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 {
-    JoystickImpl *device = impl_from_IDirectInputDevice8W(iface);
+    JoystickImpl *device = impl_from_unix_joystick(ptr);
+    IDirectInputDevice8W *iface = IDirectInputDevice8W_from_impl(device);
     IOHIDElementRef device_main_element;
     IOHIDDeviceRef hid_device;
 
@@ -928,6 +943,11 @@ static void poll_osx_device_state(IDirectInputDevice8W *iface)
     }
 }
 
+static const struct unix_joystick_vtbl unix_joystick_vtbl =
+{
+    unix_joystick_poll,
+};
+
 static INT find_joystick_devices(void)
 {
     static INT joystick_devices_count = -1;
@@ -1067,11 +1087,11 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
                        &didi, dinput, (void **)&newDevice)))
         return hr;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
+    newDevice->generic.unix_funcs = &unix_joystick_vtbl;
+    newDevice->generic.unix_ptr = unix_joystick_from_impl(newDevice);
 
     newDevice->id = index;
 
-    newDevice->generic.joy_polldev = poll_osx_device_state;
-
     /* get the device name */
     get_osx_device_name(index, name, MAX_PATH);
     TRACE("Name %s\n",name);
